Index: trunk/drmaa_utils/drmaa_utils/common.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/common.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/common.h	(revision 1)
@@ -0,0 +1,53 @@
+/* $Id: common.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __DRMAA_UTILS__COMMON_H
+#define __DRMAA_UTILS__COMMON_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/compat.h>
+#include <drmaa_utils/exception.h>
+#include <drmaa_utils/logging.h>
+#include <drmaa_utils/xmalloc.h>
+
+#define FSD_SAFE_STR(str) ( str != NULL ? str : "(null)" )
+
+/* configuration */
+typedef struct fsd_conf_option_s  fsd_conf_option_t;
+typedef struct fsd_conf_dict_s    fsd_conf_dict_t;
+
+/* iterator */
+typedef struct fsd_iter_s fsd_iter_t;
+
+/* template type */
+typedef struct fsd_attribute_s  fsd_attribute_t;
+typedef struct fsd_template_s   fsd_template_t;
+
+/* DRMAA structures */
+typedef struct fsd_drmaa_singletone_s  fsd_drmaa_singletone_t;
+typedef struct fsd_drmaa_session_s     fsd_drmaa_session_t;
+typedef struct fsd_job_set_s           fsd_job_set_t;
+typedef struct fsd_job_s               fsd_job_t;
+typedef struct fsd_expand_drmaa_ph_s   fsd_expand_drmaa_ph_t;
+
+#endif /* __DRMAA_UTILS__COMMON_H */
+
Index: trunk/drmaa_utils/drmaa_utils/exception.c
===================================================================
--- trunk/drmaa_utils/drmaa_utils/exception.c	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/exception.c	(revision 1)
@@ -0,0 +1,610 @@
+/* $Id: exception.c 321 2010-09-21 16:06:45Z mmatloka $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <errno.h>
+#include <string.h>
+#include <stdlib.h>
+
+#include <pthread.h>
+
+#include <drmaa_utils/common.h>
+#include <drmaa_utils/exception.h>
+
+
+#ifndef lint
+static char rcsid[]
+#	ifdef __GNUC__
+		__attribute__ ((unused))
+#	endif
+	= "$Id: exception.c 321 2010-09-21 16:06:45Z mmatloka $";
+#endif
+
+
+int fsd_exc_code( const fsd_exc_t *self );
+const char *fsd_exc_message( const fsd_exc_t *self );
+void fsd_exc_destroy( fsd_exc_t *self );
+
+#define EXC_INITIALIZER( code, message ) \
+ { \
+	fsd_exc_code, fsd_exc_message, fsd_exc_destroy, \
+	code, message, false, false \
+ }
+
+static const fsd_exc_t no_memory_exception \
+	= EXC_INITIALIZER( FSD_ERRNO_NO_MEMORY, "Not enough memory." );
+
+
+/**
+ * Thread specific stack of restore points
+ * @see fsd_exc_try_block_t
+ */
+typedef struct fsd_exc_stack_s {
+	fsd_exc_try_block_t **restore_points;
+	int n_restore_points;
+} fsd_exc_stack_t;
+
+
+static pthread_key_t fsd_exc_stack;
+static pthread_once_t fsd_exc_init_once = PTHREAD_ONCE_INIT;
+
+
+static void
+fsd_exc_stack_destroy( fsd_exc_stack_t *stack );
+
+
+void
+fsd_exc_init(void)
+{
+	int rc;
+	fsd_log_enter((""));
+	rc = pthread_key_create(
+			&fsd_exc_stack,
+			(void (*)(void*))fsd_exc_stack_destroy
+			);
+	if( rc )
+	 {
+		char errbuf[256] = "InternalError";
+		(void)strerror_r(errno, errbuf, 256);
+		fsd_log_fatal(( "pthread_key_create: %s",errbuf ));
+		abort();
+	 }
+	fsd_log_return((""));
+}
+
+
+fsd_exc_stack_t *
+fsd_exc_get_stack( bool create )
+{
+	fsd_exc_stack_t *stack = NULL;
+	int rc;
+
+	rc = pthread_once( &fsd_exc_init_once, fsd_exc_init );
+	if( rc )
+	 {
+		char errbuf[256] = "InternalError";
+		(void)strerror_r(errno, errbuf, 256);
+		fsd_log_fatal(( "pthread_once: %s",errbuf));
+		abort();
+	 }
+	stack = (fsd_exc_stack_t*)pthread_getspecific( fsd_exc_stack );
+	if( stack == NULL  &&  create )
+	 {
+		rc = fsd_malloc_noraise( stack, fsd_exc_stack_t );
+		if( rc )  return NULL;
+		stack->restore_points = NULL;
+		stack->n_restore_points = 0;
+		rc = pthread_setspecific( fsd_exc_stack, stack );
+		if( rc  &&  errno != ENOMEM )
+		 {
+			char errbuf[256] = "InternalError";
+			(void)strerror_r(errno, errbuf, 256);
+			fsd_log_fatal(( "pthread_setspecific: %s",errbuf ));
+			abort();
+		 }
+		else if( rc )
+		 {
+			fsd_exc_stack_destroy( stack );
+		 }
+	 }
+	else
+		fsd_assert( stack != NULL );
+	return stack;
+}
+
+
+void
+fsd_exc_stack_destroy( fsd_exc_stack_t *stack )
+{
+	int i;
+	fsd_log_enter((""));
+	for( i = 0;  i < stack->n_restore_points;  i++ )
+	 {
+		fsd_exc_try_block_t *b = stack->restore_points[i];
+		if( b->handled_exc != NULL )
+			b->handled_exc->destroy( b->handled_exc );
+		fsd_free( b );
+	 }
+	fsd_free( stack->restore_points );
+	fsd_free( stack );
+	fsd_log_return((""));
+}
+
+
+fsd_exc_try_block_t *
+fsd_exc_try( const char *function, int lineno )
+{
+	fsd_exc_stack_t *stack = NULL;
+	fsd_exc_try_block_t *p = NULL;
+	int rc;
+
+	/* fsd_log_enter(( "(%s, %d)", function, lineno )); */
+	stack = fsd_exc_get_stack( true );
+	if( stack == NULL )
+		return NULL;
+
+	rc = fsd_realloc_noraise(
+			stack->restore_points, stack->n_restore_points+1,
+			fsd_exc_try_block_t* );
+	if( rc )
+		return NULL;
+	rc = fsd_malloc_noraise( p, fsd_exc_try_block_t );
+	if( rc )
+		return NULL;
+	p->handled_exc = NULL;
+	p->state = FSD_EXC_ENTER;
+	p->function = function;
+	p->lineno = lineno;
+	stack->restore_points[ stack->n_restore_points++ ] = p;
+	/* fsd_log_return(( " =%p", (void*)p )); */
+	return p;
+}
+
+
+void
+fsd_exc_control( fsd_exc_try_block_t *block, int *rc )
+{
+	/* fsd_log_enter(( "(block=%p, rc=%d)", (void*)block, *rc )); */
+	if( block == NULL  ||  *rc == FSD_ERRNO_EXC_END )
+		return;
+
+	switch( block->state )
+	 {
+		case FSD_EXC_ENTER:
+			block->state = FSD_EXC_TRY_BLOCK;
+			fsd_assert( *rc == 0 );
+			/* fsd_log_return(( ": rc=%d => %s:%d",
+						*rc, block->function, block->lineno )); */
+			return;
+
+		case FSD_EXC_TRY_BLOCK:
+			if( *rc == 0 )
+			 {
+				block->state = FSD_EXC_ELSE_BLOCK;
+				/* fsd_log_return(( ": rc=FSD_ERRNO_EXC_ELSE => %s:%d",
+							block->function, block->lineno )); */
+				*rc = FSD_ERRNO_EXC_ELSE;
+				return;
+			 }
+			else
+			 {
+				fsd_assert( *rc > 0 );
+				block->state = FSD_EXC_EXCEPTION_HANDLE;
+				/* fsd_log_return(( ": rc=%d => %s:%d",
+							*rc, block->function, block->lineno )); */
+				return;
+			 }
+
+		case FSD_EXC_EXCEPTION_HANDLE:
+		case FSD_EXC_ELSE_BLOCK:
+			block->state = FSD_EXC_FINALLY_BLOCK;
+			/* fsd_log_return(( ": rc=FSD_ERRNO_EXC_FINALLY => %s:%d",
+						block->function, block->lineno )); */
+			*rc = FSD_ERRNO_EXC_FINALLY;
+			return;
+
+		case FSD_EXC_FINALLY_BLOCK:
+		 {
+			fsd_exc_try_block_t *current = NULL;
+			fsd_exc_try_block_t *upper = NULL;
+			fsd_exc_stack_t *stack = NULL;
+
+			block->state = FSD_EXC_LEAVE;
+
+			stack = fsd_exc_get_stack( false );
+			current = stack->restore_points[ stack->n_restore_points-1 ];
+			fsd_assert( block == current );
+			if( stack->n_restore_points > 1 )
+				upper = stack->restore_points[ stack->n_restore_points-2 ];
+			stack->n_restore_points --;
+
+			if( current->handled_exc  &&  upper )
+			 {
+				if( upper->handled_exc )
+				 {
+					fsd_assert( upper->state == FSD_EXC_EXCEPTION_HANDLE
+							|| upper->state == FSD_EXC_FINALLY_BLOCK );
+					if( upper->state == FSD_EXC_FINALLY_BLOCK )
+						fsd_log_warning((
+									"overriding previously raised exception: <%d:%s>",
+									upper->handled_exc->_code, upper->handled_exc->_message ));
+					upper->handled_exc->destroy( upper->handled_exc );
+				 }
+				upper->handled_exc = current->handled_exc;
+				/* current->handled_exc = NULL; */
+				fsd_free_noraise( current );
+				/* fsd_log_return(( ": longjmp(..., %d) => %s:%d",
+							upper->handled_exc->_code, upper->function, upper->lineno )); */
+				longjmp( upper->env, upper->handled_exc->_code );
+			 }
+			else
+			 {
+				if( current->handled_exc )
+					current->handled_exc->destroy( current->handled_exc );
+				fsd_free_noraise( current );
+				/* fsd_log_return(( ": rc=FSD_ERRNO_EXC_END => %s:%d",
+							block->function, block->lineno )); */
+				*rc = FSD_ERRNO_EXC_END;
+				return;
+			 }
+		 }
+
+		default:
+			fsd_assert(false);
+	 }
+
+	/* no return */
+}
+
+
+const fsd_exc_t *
+fsd_exc_get(void)
+{
+	fsd_exc_stack_t *stack;
+	fsd_exc_try_block_t *block;
+	stack = fsd_exc_get_stack( false );
+	fsd_assert( stack->n_restore_points > 0 );
+	block = stack->restore_points[ stack->n_restore_points-1 ];
+	return block->handled_exc;
+}
+
+
+void
+fsd_exc_clear(void)
+{
+	fsd_exc_stack_t *stack;
+	fsd_exc_try_block_t *block;
+	fsd_log_enter((""));
+	stack = fsd_exc_get_stack( false );
+	fsd_assert( stack->n_restore_points > 0 );
+	block = stack->restore_points[ stack->n_restore_points-1 ];
+	if( block->handled_exc )
+		block->handled_exc->destroy( block->handled_exc );
+	block->handled_exc = NULL;
+	fsd_log_return((""));
+}
+
+
+fsd_exc_t *
+fsd_exc_new( int code, char *message, bool own_message )
+{
+	fsd_exc_t *exc = NULL;
+	char *volatile message_buffer = NULL;
+
+	fsd_log_error(("fsd_exc_new(%d,%s,%d)", code, message, own_message));
+
+	TRY
+	 {
+		if( own_message )
+			message_buffer = message;
+		fsd_malloc( exc, fsd_exc_t );
+		exc->_code = code;
+		exc->_message = message;
+		exc->_own_message = own_message;
+		exc->_own_self = true;
+		exc->code = fsd_exc_code;
+		exc->message = fsd_exc_message;
+		exc->destroy = fsd_exc_destroy;
+	 }
+	EXCEPT_DEFAULT
+	 {
+		fsd_free( message_buffer );
+		fsd_exc_reraise();
+	 }
+	END_TRY
+	return exc;
+}
+
+int
+fsd_exc_code( const fsd_exc_t *self )
+{
+	return self->_code;
+}
+
+const char *
+fsd_exc_message( const fsd_exc_t *self )
+{
+	return self->_message;
+}
+
+void
+fsd_exc_destroy( fsd_exc_t *self )
+{
+	if( self->_own_message )
+		fsd_free_noraise( self->_message );
+	if( self->_own_self )
+		fsd_free_noraise( self );
+}
+
+
+void
+fsd_exc_raise( fsd_exc_t *exc )
+{
+	fsd_exc_stack_t *stack = NULL;
+	fsd_exc_try_block_t *block = NULL;
+	fsd_assert(( exc->_code > 0 ));
+	stack = fsd_exc_get_stack( false );
+	fsd_assert(( stack->n_restore_points > 0 ));
+	block = stack->restore_points[ stack->n_restore_points - 1 ];
+	if( block->handled_exc )
+		block->handled_exc->destroy( block->handled_exc );
+	block->handled_exc = exc;
+	longjmp( block->env, exc->_code );
+}
+
+
+void
+fsd_exc_raise_code( int error_code )
+{
+	fsd_exc_t *exc;
+
+	if( error_code == FSD_ERRNO_NO_MEMORY )
+		exc = (fsd_exc_t*)&no_memory_exception;
+	else
+		exc = fsd_exc_new( error_code, (char*)fsd_strerror(error_code), false );
+	fsd_exc_raise( exc );
+}
+
+void
+fsd_exc_raise_msg( int error_code, const char *message )
+{
+	fsd_exc_raise(
+			fsd_exc_new( error_code, fsd_strdup(message), true ) );
+}
+
+void
+fsd_exc_raise_fmt( int error_code, const char *fmt, ... )
+{
+	va_list args;
+	va_start( args, fmt );
+	fsd_exc_raise_fmtv( error_code, fmt, args );
+	va_end( args );
+}
+
+void
+fsd_exc_raise_fmtv( int error_code, const char *fmt, va_list args )
+{
+	fsd_exc_t *exc = NULL;
+	char *volatile message = NULL;
+	TRY
+	 {
+		message = fsd_vasprintf( fmt, args );
+		exc = fsd_exc_new( error_code, message, true );
+		message = NULL;
+	 }
+	FINALLY
+	 {
+		fsd_free( message );
+	 }
+	END_TRY
+	fsd_exc_raise( exc );
+}
+
+void
+fsd_exc_raise_sys( int errno_code )
+{
+	fsd_exc_t *exc = NULL;
+
+	if( errno_code == 0 )
+		errno_code = errno;
+	if( errno_code == ENOMEM )
+		exc = (fsd_exc_t*)&no_memory_exception;
+	else
+	 {
+		int code;
+		char* volatile message = NULL;
+		volatile bool own_message = false;
+		TRY
+		 {
+			switch( errno_code )
+			 {
+				case ETIMEDOUT:  code = FSD_ERRNO_TIMEOUT;  break;
+				default:         code = FSD_ERRNO_INTERNAL_ERROR;  break;
+			 }
+			message = (char*)fsd_astrerror( errno_code, (bool*)&own_message );
+			exc = fsd_exc_new( code, message, own_message );
+		 }
+		EXCEPT_DEFAULT
+		 {
+			if( message && own_message )
+				fsd_free( message );
+			fsd_exc_reraise();
+		 }
+		END_TRY
+	 }
+	fsd_exc_raise( exc );
+}
+
+
+void
+fsd_exc_reraise(void)
+{
+	fsd_exc_stack_t *stack = NULL;
+	fsd_exc_try_block_t *block = NULL;
+	stack = fsd_exc_get_stack( false );
+	fsd_assert(( stack->n_restore_points > 0 ));
+	block = stack->restore_points[ stack->n_restore_points - 1 ];
+	fsd_assert(( block->handled_exc->_code > 0 ));
+	longjmp( block->env, block->handled_exc->_code );
+}
+
+
+const char *
+fsd_strerror( int error_code )
+{
+	switch( error_code )
+	 {
+		case FSD_ERRNO_SUCCESS:
+			return "Success.";
+		case FSD_ERRNO_INTERNAL_ERROR:
+			return "Unexpected or internal error.";
+		case FSD_ERRNO_NO_MEMORY:
+			return "Not enough memory.";
+		case FSD_ERRNO_INVALID_ARGUMENT:
+			return "Invalid argument value.";
+		case FSD_ERRNO_INVALID_VALUE:
+			return "Invalid value.";
+		case FSD_ERRNO_INVALID_VALUE_FORMAT:
+			return "Invalid value format.";
+		case FSD_ERRNO_STOP_ITERATION:
+			return "Vector have no more elements.";
+		case FSD_ERRNO_NOT_IMPLEMENTED:
+			return "Functionality is not implemented.";
+		case FSD_ERRNO_NOT_INITIALIZED:
+			return "Library is not initialized";
+		case FSD_ERRNO_TIMEOUT:
+			return "Routine returned due to time-out.";
+		case FSD_ERRNO_AUTH_FAILURE:
+			return "Authentication failure.";
+		case FSD_ERRNO_AUTHZ_FAILURE:
+			return "Authorization failure";
+		case FSD_ERRNO_TRY_LATER:
+			return "System is overloaded.  Try again later.";
+		case FSD_ERRNO_DRM_COMMUNICATION_FAILURE:
+			return "Could not contact DRM system for this request.";
+		case FSD_ERRNO_DRMS_INIT_FAILED:
+			return "Unable to initialize DRM system.";
+		case FSD_ERRNO_DRMS_EXIT_ERROR:
+			return "Disengagement from the DRM system failed.";
+		case FSD_ERRNO_DENIED_BY_DRM:
+			return "DRM rejected request due to its configuration "
+				"or request attributes.";
+
+		case FSD_DRMAA_ERRNO_NO_ACTIVE_SESSION:
+			return "No active DRMAA session.";
+		case FSD_DRMAA_ERRNO_INVALID_CONTACT_STRING:
+			return "Invalid contact string.";
+		case FSD_DRMAA_ERRNO_DEFAULT_CONTACT_STRING_ERROR:
+			return "Can not determine default contact to DRM system.";
+		case FSD_DRMAA_ERRNO_NO_DEFAULT_CONTACT_STRING_SELECTED:
+			return "Contact to DRM must be set explicitly "
+				"because there is no default.";
+		case FSD_DRMAA_ERRNO_ALREADY_ACTIVE_SESSION:
+			return "DRMAA session already exist.";
+		case FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_FORMAT:
+			return "Invalid format of job attribute.";
+		case FSD_DRMAA_ERRNO_INVALID_ATTRIBUTE_VALUE:
+			return "Invalid value of job attribute.";
+		case FSD_DRMAA_ERRNO_CONFLICTING_ATTRIBUTE_VALUES:
+			return "Value of attribute conflicts with other attribute value.";
+		case FSD_DRMAA_ERRNO_INVALID_JOB:
+			return "Job does not exist in DRMs queue.";
+		case FSD_DRMAA_ERRNO_RESUME_INCONSISTENT_STATE:
+			return "Can not resume job (not in valid state).";
+		case FSD_DRMAA_ERRNO_SUSPEND_INCONSISTENT_STATE:
+			return "Can not suspend job (not in valid state).";
+		case FSD_DRMAA_ERRNO_HOLD_INCONSISTENT_STATE:
+			return "Can not hold job (not in valid state).";
+		case FSD_DRMAA_ERRNO_RELEASE_INCONSISTENT_STATE:
+			return "Can not release job (not in valid state).";
+		case FSD_DRMAA_ERRNO_EXIT_TIMEOUT:
+			return "Waiting for job to terminate finished due to time-out.";
+		case FSD_DRMAA_ERRNO_NO_RUSAGE:
+			return "Job finished but resource usage information "
+				"and/or termination status could not be provided.";
+
+		case FSD_ARES_ERRNO_INVALID_CONTACT_STRING:
+			return "Invalid contact string.";
+		case FSD_ARES_ERRNO_INVALID_ATTRIBUTE_FORMAT:
+			return "Invalid format of job attribute.";
+		case FSD_ARES_ERRNO_INVALID_ATTRIBUTE_VALUE:
+			return "Invalid value of job attribute.";
+		case FSD_ARES_ERRNO_CONFLICTING_ATTRIBUTE_VALUES:
+			return "Value of attribute conflicts with other attribute value.";
+		case FSD_ARES_ERRNO_INVALID_ARES:
+			return "Invalid advance reservation identifier..";
+
+		default:
+			return "Unknown error code!?";
+	 }
+}
+
+
+static const int fsd_stacktrace_length = 32;
+
+void
+fsd_assertion_failed(
+		const char *file, int lineno,
+		const char *function, const char *precondition
+		)
+{
+	char *message = NULL;
+	if( asprintf( &message, "%s:%d: %s: Assertion `%s' failed.",
+			file, lineno, function, precondition ) == -1 )
+		message = NULL;
+	if( message != NULL )
+		fsd_log_fatal(( "%s", message ));
+	fsd_log_stacktrace( 1, fsd_stacktrace_length );
+	if( message != NULL )
+		free( message );
+	abort();
+}
+
+
+void *
+fsd_exc_try_except(
+		void*(*f)(void*), void *data,
+		int *error_code,
+		char **error_message
+		)
+{
+	void *result = NULL;
+	TRY
+	 {
+		result = f( data );
+	 }
+	EXCEPT_DEFAULT
+	 {
+		const fsd_exc_t *e = fsd_exc_get();
+		*error_code = e->code(e);
+		*error_message = fsd_strdup( e->message(e) );
+	 }
+	ELSE
+	 {
+		*error_code = FSD_ERRNO_SUCCESS;
+		*error_message = NULL;
+	 }
+	END_TRY
+	return result;
+}
+
+
Index: trunk/drmaa_utils/drmaa_utils/drmaa_attrib.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/drmaa_attrib.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/drmaa_attrib.h	(revision 1)
@@ -0,0 +1,70 @@
+/* $Id: drmaa_attrib.h 2 2009-10-12 09:51:22Z mamonski $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file attrib.h
+ * DRMAA attributes.
+ */
+#ifndef __DRMAA_UTILS__DRMAA_ATTRIB_H
+#define __DRMAA_UTILS__DRMAA_ATTRIB_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/compat.h>
+#include <drmaa_utils/drmaa.h>
+#include <drmaa_utils/common.h>
+
+/**
+ * Attributes codes.
+ */
+enum {
+	/* DRMAA 1.0 attributes: */
+	DRMAA_ATTR_REMOTE_COMMAND,
+	DRMAA_ATTR_ARGS, /* vector */
+	DRMAA_ATTR_JOB_SUBMISSION_STATE,
+	DRMAA_ATTR_JOB_ENVIRONMENT, /* vector */
+	DRMAA_ATTR_WORKING_DIRECTORY,
+	DRMAA_ATTR_JOB_CATEGORY,
+	DRMAA_ATTR_NATIVE_SPECIFICATION,
+	DRMAA_ATTR_EMAIL, /* vector */
+	DRMAA_ATTR_BLOCK_EMAIL,
+	DRMAA_ATTR_START_TIME,
+	DRMAA_ATTR_JOB_NAME,
+	DRMAA_ATTR_INPUT_PATH,
+	DRMAA_ATTR_OUTPUT_PATH,
+	DRMAA_ATTR_ERROR_PATH,
+	DRMAA_ATTR_JOIN_FILES,
+	/* optional DRMAA attributes: */
+	DRMAA_ATTR_TRANSFER_FILES,
+	DRMAA_ATTR_DEADLINE_TIME,
+	DRMAA_ATTR_HARD_WALL_CLOCK_TIME_LIMIT,
+	DRMAA_ATTR_SOFT_WALL_CLOCK_TIME_LIMIT,
+	DRMAA_ATTR_HARD_RUN_DURATION_LIMIT,
+	DRMAA_ATTR_SOFT_RUN_DURATION_LIMIT,
+
+	DRMAA_N_ATTRIBUTES
+};
+
+fsd_template_t *
+drmaa_template_new(void);
+
+#endif /* __DRMAA_UTILS__DRMAA_ATTRIB_H */
+
Index: trunk/drmaa_utils/drmaa_utils/lookup3.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/lookup3.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/lookup3.h	(revision 1)
@@ -0,0 +1,25 @@
+/* $Id: lookup3.h 2 2009-10-12 09:51:22Z mamonski $ */
+
+#ifndef __LOOKUP3_H
+#define __LOOKUP3_H
+
+#ifdef HAVE_CONFIG_H
+#	include <config.h>
+#endif
+
+#include <drmaa_utils/compat.h>
+
+uint32_t hashword( const uint32_t *k, size_t length, uint32_t initval );
+uint32_t hashlittle( const void *key, size_t length, uint32_t initval );
+uint32_t hashbig( const void *key, size_t length, uint32_t initval );
+
+#if BYTEORDER == 1234 /* little endian */
+#	define hashstr hashlittle
+#endif
+
+#if BYTEORDER == 4321  /* big endian */
+#	define hashstr hashbig
+#endif
+
+#endif /* __LOOKUP3_H */
+
Index: trunk/drmaa_utils/drmaa_utils/conf_tab.y
===================================================================
--- trunk/drmaa_utils/drmaa_utils/conf_tab.y	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/conf_tab.y	(revision 1)
@@ -0,0 +1,139 @@
+/* $Id: conf_tab.y 2172 2009-02-28 14:26:23Z lukasz $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+%{
+#ifdef HAVE_MALLOC_H
+#       include <malloc.h>
+#endif
+#include <drmaa_utils/conf_impl.h>
+#include <drmaa_utils/conf_tab.h>
+%}
+
+%pure-parser
+%locations
+%name-prefix="fsd_conf_"
+%parse-param { fsd_conf_parser_t *parser }
+%parse-param { fsd_conf_lexer_t *lexer }
+%lex-param { fsd_conf_lexer_t *lexer }
+
+
+%union {
+	int integer;
+	char *string;
+	fsd_conf_option_t *option;
+	fsd_conf_dict_t *dictionary;
+	fsd_conf_pair_t pair;
+}
+
+%type<option> value
+%destructor { fsd_conf_option_destroy($$); } value
+%type<dictionary> start conf dict dict_body pair_list
+%destructor { fsd_conf_dict_destroy($$); } conf dict dict_body pair_list
+%type<pair> pair
+%token<integer> INTEGER
+%token<string> STRING
+%destructor { free($$); } STRING
+%token LEXER_ERROR
+
+
+%%
+
+start
+	: conf { parser->result = $1;  $$ = NULL; }
+	;
+
+conf
+	: dict
+	| dict_body
+	;
+
+dict
+	: '{' dict_body '}' { $$ = $2; }
+	;
+
+dict_body
+	: pair_list  { $$ = $1; }
+	| pair_list ','  { $$ = $1; }
+	| {
+		$$ = fsd_conf_dict_create_noraise();
+		if( $$ == NULL )  YYABORT;
+	}
+	;
+
+pair_list
+	: pair
+		 {
+			fsd_conf_dict_t *dict = NULL;
+			int rc;
+			dict = fsd_conf_dict_create_noraise();
+			if( dict == NULL )
+				YYABORT;
+			rc = fsd_conf_dict_set_noraise( dict, $1.key, $1.value );
+			if( rc )
+			 {
+				fsd_conf_dict_destroy( dict );
+				YYABORT;
+			 }
+			$$ = dict;
+		 }
+	| pair_list ',' pair
+		 {
+			int rc;
+			rc = fsd_conf_dict_set_noraise( $1, $3.key, $3.value );
+			if( rc )
+				YYABORT;
+			$$ = $1; /* explicit no op */
+		 }
+	;
+
+pair
+	: STRING ':' value { $$.key = $1;  $$.value = $3; }
+	;
+
+value
+	: INTEGER
+		 {
+			fsd_conf_option_t *o;
+			o = fsd_conf_option_create_noraise( FSD_CONF_INTEGER, &$1 );
+			if( o )
+				$$ = o;
+			else
+				YYABORT;
+		 }
+	| STRING
+		 {
+			fsd_conf_option_t *o;
+			o = fsd_conf_option_create_noraise( FSD_CONF_STRING, $1 );
+			if( o )
+				$$ = o;
+			else
+				YYABORT;
+		 }
+	| dict
+		 {
+			fsd_conf_option_t *o;
+			o = fsd_conf_option_create_noraise( FSD_CONF_DICT, $1 );
+			if( o )
+				$$ = o;
+			else
+				YYABORT;
+		 }
+	;
+
+%%
Index: trunk/drmaa_utils/drmaa_utils/datetime.h
===================================================================
--- trunk/drmaa_utils/drmaa_utils/datetime.h	(revision 1)
+++ trunk/drmaa_utils/drmaa_utils/datetime.h	(revision 1)
@@ -0,0 +1,116 @@
+/* $Id: datetime.h 296 2010-09-15 13:21:14Z mmatloka $ */
+/*
+ *  FedStage DRMAA utilities library
+ *  Copyright (C) 2006-2008  FedStage Systems
+ *
+ *  This program is free software: you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation, either version 3 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/**
+ * @file datetime.h
+ * DRMAA and ISO-8601 date/time parser.
+ */
+
+#ifndef __DRMAA_UTILS__DATETIME_H
+#define __DRMAA_UTILS__DATETIME_H
+
+#include <drmaa_utils/common.h>
+
+/**
+ * @defgroup datetime  DRMAA date/time parser.
+ *
+ * It parses date/time string in format of
+ * drmaa_start_time and drmaa_deadline_time attributes.
+ * In other words it accepts time in following format:
+ *
+ * <tt>  [[[[CC]YY/]MM/]DD] hh:mm[:ss] [{-|+}UU:uu]  </tt>
+ *
+ * where
+ *    CC is the first two digits of the year (century-1),
+ *    YY is the last two digits of the year,
+ *    MM is the two digits of the month [01,12],
+ *    DD is the two-digit day of the month [01,31],
+ *    hh is the two-digit hour of the day [00,23],
+ *    mm is the two-digit minute of the day [00,59],
+ *    ss is the two-digit second of the minute [00,61],
+ *    UU is the two-digit hours since (before) UTC,
+ *    uu is the two-digit minutes since (before) UTC.
+ */
+/* @{ */
+
+typedef struct fsd_datetime_s fsd_datetime_t;
+
+/**
+ * Parses date/time.
+ * @param string  Textual representation to date/time.
+ * @return Absolute time according to string.
+ */
+time_t fsd_datetime_parse( const char *string );
+
+/**
+ * Return first timestamp after \a t
+ * which match date/time pattern \a dt.
+ */
+time_t fsd_datetime_after( fsd_datetime_t *dt, time_t t );
+
+/**
+ * Fill unset fields of fsd_datetime_t structure according to timestamp.
+ * @param dt   Will be filled with local time representation of filler.
+ * @param filler  Seconds since epoch.
+ */
+void fsd_datetime_fill( fsd_datetime_t *dt, time_t filler );
+
+/** Makes UTC datetime from (possibly not absolute) fsd_datetime_t. */
+time_t fsd_datetime_mktime( const fsd_datetime_t *dt );
+
+enum{
+	FSD_DT_YEAR         = 1<<0,
+	FSD_DT_MONTH        = 1<<1,
+	FSD_DT_DAY          = 1<<2,
+	FSD_DT_HOUR         = 1<<3,
+	FSD_DT_MINUTE       = 1<<4,
+	FSD_DT_SECOND       = 1<<5,
+	FSD_DT_TZ_DELTA     = 1<<6,
+	FSD_DT_ALL = FSD_DT_YEAR | FSD_DT_MONTH | FSD_DT_DAY
+		| FSD_DT_HOUR | FSD_DT_MINUTE | FSD_DT_SECOND | FSD_DT_TZ_DELTA
+};
+
+/** Intermediate result of parsing date/time string (may be incomplete). */
+struct fsd_datetime_s {
+	unsigned mask;  /**< Bit-set of fields which were set. */
+	int year;       /**< Year. */
+	int month;      /**< Month. */
+	int day;        /**< Day. */
+	int hour;       /**< Hour. */
+	int minute;     /**< Minute. */
+	int second;     /**< Second. */
+	long tz_delta;  /**< Timezone; Number of seconds ahead of UTC. */
+};
+
+
+/**
+ * Guess local timezone for given UTC time
+ * @param t UTC timestamp (time from epoch).
+ * @return Numbef of seconds east (since/before) UTC.  For example in CET
+ * +3600 is returned (UTC + 1 hour).
+ */
+long fsd_timezone( time_t t );
+
+/* @} */
+
+void
+fsd_datetime_dump( const fsd_datetime_t *dt, char *s, size_t len );
+
+#endif /* __DRMAA_UTILS__DATETIME_H */
+
